config/routes.rb
Rails.application.routes.draw do
  get 'password_resets/new'
  get 'password_resets/edit'
  scope '(:locale)', locale: /en|vi/ do
    root 'static_pages#home'
    get '/contact', to: 'static_pages#contact'
    get '/signup', to: 'users#new'
    get '/news', to: 'news#index'

    get '/login', to: 'sessions#new'
    post '/login', to: 'sessions#create'
    get '/logout', to: 'sessions#destroy'

    resources :users, only: %i[new create show]
    resources :account_activations, only: :edit
    resources :password_resets, only: %i[new create edit update]
    resources :news
    resources :comments
    resources :categories
    resources :likes
    resources :like_comments
  end
end

app/models/category.rb
# frozen_string_literal: true

class Category < ApplicationRecord
  has_many :new, dependent: :restrict_with_error
  accepts_nested_attributes_for :new
  validates :name, presence: true
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  attr_accessor :name

  # scope by_name order(:name)

  before_action :find_category, only: %i[show edit update destroy]

  def index
    @categories = Category.all
  end

  def new
    @category = Category.new
    # @category.new.build
  end

  def show; end

  def create
    params[new_attributes: :user_id] = current_user.id
    @category = Category.new(category_params)
    if @category.save
      flash[:success] = t 'common.created_successfully'
      redirect_to categories_path
    else
      flash[:danger] = t 'common.created_fail'
      render :'categories/new'
    end
  end

  def edit; end

  def update
    if @category.update(category_params)
      flash[:success] = t 'common.updated_successfully'
      redirect_to categories_path
    else
      render :'categories/edit'
    end
  end

  def destroy
    @category.destroy
    flash[:danger] = t '.deleted_fail_father' if @category.new.count.positive?
    flash[:success] = t 'common.deleted_successfully' if @category.new.count.zero?
    redirect_to categories_path
  end

  private

  def category_params
    params.require(:category).permit(:name,
                                     new_attributes: [:title, :content, :thump, { user_id: current_user.id }])
  end

  def find_category
    @category = Category.find(params[:id])
  end

end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/views/categories/edit.html.erb
<h1><%= t "categories.edit.title" %></h1>
<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <% if @category %>
      <%= form_for(@category) do |f| %>
        <%= render 'shared/error_categories_messages' %>
        <%= f.label :name %>
        <%= f.text_field :name, class: 'form-control' %>
        <%= f.submit t("news.index.edit"), class: "btn btn-primary" %>
      <% end %>
    <% end %>
  </div>
</div>

app/views/categories/index.html.erb
<h1><%= t ".title" %></h1>
<%= link_to "<button>Thêm mới loại tin tức</button>".html_safe, logged_in? ? new_category_path : login_path %>
<table class="table table-striped table-dark">
  <thead>
  <tr>
    <th scope="col"><%= t "common.id" %></th>
    <th scope="col"><%= t "common.name" %></th>
    <th scope="col"><%= t ".number_of_new" %></th>
    <th scope="col" colspan="2"></th>
  </tr>
  </thead>
  <tbody>
  <% @categories.each do |i| %>
    <tr>
      <td><%= i.id %></td>
      <td><%= i.name %></td>
      <td><%= i.new.count %></td>
      <td><%= link_to t("common.edit"), edit_category_url(id: i.id) %></td>
      <td><%= button_to t("common.delete"), category_url(i), method: :delete,
                      data: { confirm: t("common.you_sure?") } %></td>
    </tr>
  <% end %>
  </tbody>
</table>

app/views/categories/new.html.erb
<h1><%= t "categories.new.title" %></h1>
<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <% if @category %>
      <%= form_for(@category) do |f| %>
        <%= render 'shared/error_categories_messages' %>
        <%= f.label :name %>
        <%= f.text_field :name, class: 'form-control' %>
        <br>
        <div class="field address-container">
          <%#= f.label t(".add_new"), class: 'child_title'%>
          <br>
          <%= f.fields_for :new do |add| %>
            <%= add.label :title %>
            <%= add.text_field :title, class: 'form-control street-field' %>
            <%= add.label :content %>
            <%= add.text_area :content, class: 'form-control content street-field' %>
            <%= add.label :image %>
            <%= add.file_field :thump, class: "street-field" %>
          <% end %>
        </div>
        <%= f.submit t("news.index.create"), class: "btn btn-primary" %>
      <% end %>
    <% end %>
  </div>
</div>

<script type="text/javascript">
    $(".js-btn-add").on("click", function () {
        addAddressField();
    })

    function addAddressField() {
        var length = $(".street-field").length;
        var div = document.createElement("div");
        var input = document.createElement("input");

        input.type = "text";
        input.name = "user[address_attributes][" + length + "][street]"
        input.className = "street-field"
        input.id = "user_address_attributes_" + length + "_street"

        div.appendChild(input)
        $(".address-container").append(div);
    }
</script>

<style type="text/css">
    .street-field {
        margin-top: 5px;
        margin-bottom: 5px;
    }
    .child_title{
        text-align: center;
    }
</style>